routes/web.php
<?php

/* Route For Main View */
Route::get('/', function () {
    return redirect('/login');
});

/* Route For Auth */
Auth::routes();

/* Route For Main Menu */
Route::group(
    [
        'prefix' => 'admin',
        'middleware' => ['auth', 'role:admin|marketing|operator|ppic|gudang'],
    ],
    function () {
        //Route Home
        Route::get('/home/{tahun}', 'admin\HomeController@index');
        
        //Route User
        Route::resource('master/users', 'Admin\UsersController');

        //Route Raw Material
        Route::resource('master/raws', 'Admin\RawsController');

        //Route Color Type
        Route::resource('master/colors', 'Admin\ColorsController');

        //Route Product Type
        Route::resource('master/products', 'Admin\ProductsController');

        //Route Machine Group
        Route::resource('master/groups', 'Admin\GroupsController');

        //Route Marketing (Delivery Order)
        Route::resource('marketing/orders', 'Admin\MarketingsController');
        Route::get('marketing/orders/get_id/{table}', [
            'as' => 'orders.getId',
            'uses' => 'Admin\MarketingsController@getId',
        ]);
        Route::get('marketing/orders/product_detail/{product_id}', 'Admin\MarketingsController@productDetail');

        //Route Change Password
        Route::get('change_password', [
            'as' => 'change_password',
            'uses' => 'Admin\UsersController@changePassword',
        ]);
        Route::post('store_password', [
            'as' => 'store_password',
            'uses' => 'Admin\UsersController@storeNewPassword',
        ]);

        //Route Incoming
        Route::get('inventory/incomings/create', [
            'as' => 'incomings.create',
            'uses' => 'Admin\InvController@incCreate',
        ]);
        Route::post('inventory/incomings/inc_detail', [
            'as' => 'incomings.inc_detail',
            'uses' => 'Admin\InvController@incDetail',
        ]);
        Route::post('inventory/incomings/inc_finish', [
            'as' => 'incomings.inc_finish',
            'uses' => 'Admin\InvController@incFinish',
        ]);
        Route::get('inventory/incomings/raw_detail/{id}', [
            'uses' => 'Admin\InvController@incRawDetail',
        ]);
        Route::post('inventory/incomings/store', [
            'as' => 'incomings.store',
            'uses' => 'Admin\InvController@incStore',
        ]);
        Route::get('inventory/incomings/get_id/{table}', [
            'as' => 'incomings.getId',
            'uses' => 'Admin\InvController@getId',
        ]);

        //Route Stock Raw Material
        Route::get('inventory/stocks/raw_material', [
            'as' => 'stocks.raw_material',
            'uses' => 'Admin\InvController@rawStock',
        ]);
        Route::get('inventory/stocks/{id}/edit', [
            'as' => 'stocks.edit',
            'uses' => 'Admin\InvController@editStock',
        ]);
        Route::put('inventory/stocks/update/{id}', [
            'as' => 'stocks.update',
            'uses' => 'Admin\InvController@updateStock',
        ]);
        Route::delete('inventory/stocks/{id}', [
            'as' => 'stocks.destroy',
            'uses' => 'Admin\InvController@destroyStock',
        ]);
        Route::delete('inventory/stocks/remove/{id}', [
            'as' => 'stocks.remove',
            'uses' => 'Admin\InvController@removeStock',
        ]);
        
        //Route PPIC SPK Base Material to Coloring Order
        Route::resource('ppic/colorings', 'Admin\PpicsController');
        Route::get('ppic/colorings/get_id/{table}', [
            'as' => 'colorings.getId',
            'uses' => 'Admin\PpicsController@getId',
        ]);
        Route::get('ppic/colorings/do_detail/{table}', 'Admin\PpicsController@doDetail');

        Route::get('ppic/table/{type}', [
            'as' => 'ppic.table',
            'uses' => 'Admin\PpicsController@table',
        ]);

        //Route PPIC SPK to Cutting finish good Roll
        Route::get('ppic/cuttings', [
            'as' => 'cuttings.index',
            'uses' => 'Admin\PpicsController@cuttingIndex',
        ]);
        Route::get('ppic/cuttings/create', [
            'as' => 'cuttings.create',
            'uses' => 'Admin\PpicsController@cuttingCreate',
        ]);
        Route::get('ppic/colorings/get_laminating_id/{table}', [
            'as' => 'colorings.getLaminatingId',
            'uses' => 'Admin\PpicsController@getLaminatingId',
        ]);
        Route::post('ppic/cuttings/store', [
            'as' => 'cuttings.store',
            'uses' => 'Admin\PpicsController@cuttingStore',
        ]);
        Route::get('ppic/cuttings/{cutting}/edit', [
            'as' => 'cuttings.edit',
            'uses' => 'Admin\PpicsController@cuttingEdit',
        ]);
        Route::put('ppic/cuttings/{cutting}', [
            'as' => 'cuttings.update',
            'uses' => 'Admin\PpicsController@cuttingUpdate',
        ]);
        Route::delete('ppic/cuttings/{cutting}', [
            'as' => 'cuttings.destroy',
            'uses' => 'Admin\PpicsController@cuttingDestroy',
        ]);

        //Route Production
        Route::get('production/base', [
            'as' => 'productions.base',
            'uses' => 'Admin\ProductionsController@baseColored',
        ]);
        Route::get('production/base/table_status', 'Admin\ProductionsController@tableStatus');
        Route::get('production/base/do_spk_list/{marketing_id}', 'Admin\ProductionsController@doSpk');
        Route::get('production/base/do_raw_list/{inc_detail_id}', 'Admin\ProductionsController@doRaw');
        Route::post('production/base/base_proccess', 'Admin\ProductionsController@baseProccess');
        Route::post('production/base/raw_colored_store', 'Admin\ProductionsController@rawColoredStore');
        
        Route::get('production/laminating/table_non', 'Admin\ProductionsController@tableStatusLaminatingNon');
        Route::get('production/laminating/table_colored', 'Admin\ProductionsController@tableStatusLaminatingColored');
        Route::post('production/laminating/laminating_proccess', 'Admin\ProductionsController@laminatingProccess');
        Route::get('production/laminating', 'Admin\ProductionsController@laminating');
        Route::get('production/laminating/do_spk_list/{marketing_id}', 'Admin\ProductionsController@doSpkLaminating');
        Route::get('production/laminating/do_raw_list/{color_type}/{ppic_id}', 'Admin\ProductionsController@doRawLaminating');

        Route::post('production/laminating/laminating_colored_store', 'Admin\ProductionsController@laminatingColoredStore');
        Route::post('production/laminating/laminating_colored_store_finish', 'Admin\ProductionsController@laminatingColoredStoreFinish');
        Route::post('production/laminating/laminating_noncolored_store', 'Admin\ProductionsController@laminatingNonColoredStore');
        Route::post('production/laminating/laminating_noncolored_store_finish', 'Admin\ProductionsController@laminatingNonColoredStoreFinish');
        
        Route::get('result/{tahun}/{table}', [
            'as' => 'result.index',
            'uses' => 'Admin\ResultController@index'
        ]);

        Route::get('result_fgs/{tahun}', [
            'as' => 'result.fgs',
            'uses' => 'Admin\ResultController@fgs'
        ]);

        Route::get('result_laminating/{tahun}', [
            'as' => 'result.laminating',
            'uses' => 'Admin\ResultController@laminating'
        ]);

        //SPK FGS
        Route::get('ppic/fgs', [
            'as' => 'fgs.index',
            'uses' => 'Admin\PpicsController@fgsIndex',
        ]);
        Route::get('ppic/fgs/create', [
            'as' => 'fgs.create',
            'uses' => 'Admin\PpicsController@fgsCreate',
        ]);
        Route::post('ppic/fgs/store', [
            'as' => 'fgs.store',
            'uses' => 'Admin\PpicsController@fgsStore',
        ]);
        Route::get('ppic/fgs/{fgs}/edit', [
            'as' => 'fgs.edit',
            'uses' => 'Admin\PpicsController@fgsEdit',
        ]);
        Route::put('ppic/fgs/{fgs}', [
            'as' => 'fgs.update',
            'uses' => 'Admin\PpicsController@fgsUpdate',
        ]);
        Route::delete('ppic/fgs/{fgs}', [
            'as' => 'fgs.destroy',
            'uses' => 'Admin\PpicsController@fgsDestroy',
        ]);

        Route::get('production/fgs', 'Admin\ProductionsController@fgs');

        Route::get('production/fgs/do_spk_list/{marketing_id}', 'Admin\ProductionsController@doSpkFgs');
        Route::post('production/fgs/fgs_proccess', 'Admin\ProductionsController@fgsProccess');
        Route::post('production/fgs/fgs_store', 'Admin\ProductionsController@fgsStore');
        Route::post('production/fgs/fgs_store_finish', 'Admin\ProductionsController@fgsStoreFinish');
    }
);

Route::get('auth/verify/{token}', 'Auth\RegisterController@verify');
Route::get('auth/send-verification', 'Auth\RegisterController@sendVerification');

app/Color.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Color extends Model
{
    protected $fillable = ['color_name', 'color_code', 'user_id'];
    
    public function user()
    {
        return $this->belongsTo('App\User');
    }

    public function product()
    {
        return $this->belongsTo('App\Product');
    }

    public function colored()
    {
        return $this->hasMany('App\Colored');
    }
}

app/Http/Controllers/Admin/ColorsController.php
<?php

namespace App\Http\Controllers\Admin;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Color;
use Auth;
use Datatables;
use Illuminate\Support\Str;
use Validator;

class ColorsController extends Controller
{

    public function index(Request $request)
    {
        if ($request->ajax()) {
            $colors = Color::select(['id', 'color_name', 'color_code', 'user_id'])->get();
            return Datatables::of($colors)
                ->addColumn('user', function ($color) {
                    return ucfirst($color->user->name);
                })
                ->addColumn('action', function ($color) {
                    return view('admin.datatables._action', [
                        'id' => $color->id,
                        'destroy_url' => route('colors.destroy', $color->id),
                        'edit_url' => route('colors.edit', $color->id),
                        'confirm_message' => 'Apa anda yakin ingin menghapus tipe warna ' . $color->color_name . ' ?',
                    ]);
                })
                ->rawColumns(['user', 'action'])
                ->filter(function ($instance) use ($request) {
                    if (!empty($request->get('color_name'))) {
                        $instance->collection = $instance->collection->filter(function ($row) use ($request) {
                            return Str::contains($row['color_name'], $request->get('color_name')) ? true : false;
                        });
                    }
                    if (!empty($request->get('color_code'))) {
                        $instance->collection = $instance->collection->filter(function ($row) use ($request) {
                            return Str::contains($row['color_code'], $request->get('color_code')) ? true : false;
                        });
                    }
                    if (!empty($request->get('user'))) {
                        $instance->collection = $instance->collection->filter(function ($row) use ($request) {
                            return Str::contains($row['user'], $request->get('user')) ? true : false;
                        });
                    }
                })
                ->make(true);
        }

        $data['title'] = 'Daftar Tipe Warna';
        return view('admin.color.index', $data);
    }

    public function create()
    {
        $data['title'] = 'Tambah Tipe Warna';
        return view('admin.color.create', $data);
    }

    public function store(Request $request)
    {
        
        $validator = Validator::make($request->all(), [
            'color_name' => 'required|unique:colors',
        ]);

        if ($validator->passes()) {
            $data = $request->all();
            $data['user_id'] = Auth::user()->id;
            $color = Color::create($data);
            return response()->json(['success' => 'Berhasil menambahkan Tipe Warna']);
        } else {
            return response()->json(['error' => $validator->getMessageBag()->toArray()]);
        }
    }

    public function show($id)
    {
        //
    }

    public function edit($id)
    {
        $title = 'Edit Tipe Warna';
        $color = Color::find($id);
        return view('admin.color.edit')->with(compact('color', 'title'));
    }

    public function update(Request $request, $id)
    {
        $validator = Validator::make($request->all(), [
            'color_name' => 'required|unique:colors,color_name,' . $id,
        ]);

        if ($validator->passes()) {
            $color = Color::find($id);
            $color->update($request->all());
            return response()->json(['success' => 'Berhasil mengubah data Tipe Warna']);
        } else {
            return response()->json(['error' => $validator->getMessageBag()->toArray()]);
        }
    }
    
    public function destroy($id)
    {
        $color = Color::where('id', $id)->delete();
        return response()->json(['id' => $id]);
    }
}

resources/views/admin/color/_form.blade.php
<div class="form-group group-color_name">
    {!! Form::label('color_name', 'Nama Warna', ['class' => 'col-md-3 control-label']) !!}
    <div class="col-md-9 col-xs-12">
        {!! Form::text('color_name', null, ['class' => 'form-control']) !!}
    </div>
</div>

<div class="form-group group-color_code">
    {!! Form::label('color_code', 'Kode Warna', ['class' => 'col-md-3 control-label']) !!}
    <div class="col-md-9 col-xs-12">
        {!! Form::text('color_code', null, ['class' => 'form-control']) !!}
    </div>
</div>

resources/views/admin/color/create.blade.php
@extends('admin.layouts.app')

@section('content')
<ul class="breadcrumb">
    <li>Master Data</li>
    <li>Tipe Warna</li>
    <li class="active">Tambah Data</li>
</ul>


<div class="page-content-wrap">
    <div class="row row-bg">
        <div class="col-md-12">
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title">Form Tipe Warna</h3>
                </div>
                {!! Form::open(['url' => route('colors.store'), 'class' => 'form-horizontal form-save', 'method' =>'post', 'data-rule' => 'store']) !!}
                <div class="panel-body">
                    <a class="btn btn-default waves-effect" href="{{ route('colors.index') }}">
                        <i class="fa fa-arrow-left"> Kembali</i>
                    </a>
                    <hr>
                    <div class="row">
                        <div class="col-md-6">
                            @include('admin.color._form')
                        </div>
                    </div>
                </div>
                <div class="panel-footer">
                    {!! Form::submit('Simpan', ['class'=>'btn btn-primary pull-right', 'id' => 'btn-save']) !!}
                </div>
                {!! Form::close() !!}
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/admin/color/edit.blade.php
@extends('admin.layouts.app')

@section('content')
<ul class="breadcrumb">
    <li>Master Data</li>
    <li>Tipe Warna</li>
    <li class="active">Edit</li>
</ul>

<div class="page-content-wrap">
    <div class="row row-bg">
        <div class="col-md-12">
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title">Form Tipe Warna</h3>
                </div>
                {!! Form::model($color, ['url' => route('colors.update', $color->id), 'class' => 'form-horizontal form-save',
                 'method' =>'put', 'data-redirect' => route('colors.index')]) !!}
                <div class="panel-body">
                    <a class="btn btn-default waves-effect" href="{{ route('colors.index') }}">
                        <i class="fa fa-arrow-left"> Kembali</i>
                    </a>
                    <hr>
                    <div class="row">
                        <div class="col-md-6">
                            @include('admin.color._form')
                        </div>
                    </div>
                </div>
                <div class="panel-footer">
                    {!! Form::submit('Simpan', ['class'=>'btn btn-primary pull-right', 'id' => 'btn-save']) !!}
                </div>
                {!! Form::close() !!}
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/admin/color/index.blade.php
@extends('admin.layouts.app')

@section('content')
<ul class="breadcrumb">
    <li>Master Data</li>
    <li class="active">Tipe Warna</li>
</ul>

<div class="page-content-wrap">
    <div class="row row-bg">
        <div class="col-md-12">
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title">Daftar Tipe Warna</h3>
                </div>
                <div class="panel-body">
                    <div class="row">
                        <a class="btn btn-default waves-effect" href="{{ route('colors.create') }}">Tambah Tipe Warna</a>
                        <hr>
                        <div class="col-md-12">
                            <table id="colors" class="table table-striped table-bordered">
                                <thead>
                                    <tr>
                                        <th width="10%">ID</th>
                                        <th>Tipe Warna</th>
                                        <th>Kode Warna</th>
                                        <th>Bibuat Oleh</th>
                                        <th width="10%">Action</th>
                                    </tr>
                                </thead>
                                <tfoot>
                                    <tr>
                                        <td></td>
                                        <td>
                                            {!! Form::text('color_name', null, ['class' => 'form-control', 'placeholder' => 'Tipe Warna', 'id' => 'color_name']) !!}
                                        </td>
                                        <td>
                                            {!! Form::text('color_code', null, ['class' => 'form-control', 'placeholder' => 'Kode Warna', 'id' => 'color_code']) !!}
                                        </td>
                                        <td>
                                            {!! Form::text('user', null, ['class' => 'form-control', 'placeholder' => 'Pengguna', 'id' => 'user']) !!}
                                        </td>
                                        <td></td>
                                    </tr>
                                </tfoot>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

@section('scripts')
<script type="text/javascript">
    $(function () {
        var table = $('#colors').DataTable({
            processing: false,
            serverSide: true,
            ajax: {
                url: "{{ route('colors.index') }}",
                data: function (d) {
                    d.name = $('#color_name').val(),
                    d.user = $('#user').val()
                }
            },
            columns: [{
                    data: 'id',
                    name: 'id'
                },
                {
                    data: 'color_name',
                    name: 'color_name'
                },
                {
                    data: 'color_code',
                    name: 'color_code'
                },
                {
                    data: 'user',
                    name: 'user',
                },
                {
                    data: 'action',
                    name: 'action',
                    orderable: false,
                    searchable: false
                }
            ]
        });

        $('#color_name').on('change', function () {
            table.draw();
        });

        $('#color_code').on('change', function () {
            table.draw();
        });

        $('#user').on('change', function () {
            table.draw();
        });
    });
</script>
@endsection

@section('style')
<style>
    #colors_filter {
        display: none;
    }
</style>
@endsection